<?php

namespace App\Filament\Exports;

use App\Models\ProcessOrder;
use Filament\Actions\Exports\ExportColumn;
use Filament\Actions\Exports\Exporter;
use Filament\Actions\Exports\Models\Export;

class ProcessOrderExporter extends Exporter
{
    protected static ?string $model = ProcessOrder::class;

    public static function getColumns(): array
    {
        static $rowNumber = 0;

        return [
            ExportColumn::make('no')
                ->label('NO')
                ->state(function ($record) use (&$rowNumber) {
                    // Increment and return the row number
                    return ++$rowNumber;
                }),
            ExportColumn::make('plant.code')
                ->label('PLANT CODE'),
            ExportColumn::make('line.name')
                ->label('LINE NAME'),
            ExportColumn::make('item.code')
                ->label('ITEM CODE'),
            ExportColumn::make('item.description')
                ->label('ITEM DESCRIPTION'),
            ExportColumn::make('process_order')
                ->label('PROCESS ORDER'),
            ExportColumn::make('coil_number')
                ->label('COIL NUMBER'),
            ExportColumn::make('order_quantity')
                ->label('ORDER QUANTITY'),
            ExportColumn::make('updated_order_quantity')
                ->label('UPDATED ORDER QUANTITY'),
            ExportColumn::make('received_quantity')
                ->label('RECEIVED QUANTITY'),
            ExportColumn::make('sfg_number')
                ->label('SFG NUMBER'),
            ExportColumn::make('machine_name')
                ->label('MACHINE NAME'),
            ExportColumn::make('scrap_quantity')
                ->label('SCRAP QUANTITY'),
            ExportColumn::make('rework_status')
                ->label('REWORK STATUS'),
            ExportColumn::make('created_at')
                ->label('CREATED AT'),
            ExportColumn::make('created_by')
                ->label('CREATED BY'),
            ExportColumn::make('updated_at')
                ->label('UPDATED AT'),
            ExportColumn::make('updated_by')
                ->label('UPDATED BY'),
            ExportColumn::make('deleted_at')
                ->enabledByDefault(false)
                ->label('DELETED AT'),
        ];
    }

    public static function getCompletedNotificationBody(Export $export): string
    {
        $body = 'Your process order export has completed and '.number_format($export->successful_rows).' '.str('row')->plural($export->successful_rows).' exported.';

        if ($failedRowsCount = $export->getFailedRowsCount()) {
            $body .= ' '.number_format($failedRowsCount).' '.str('row')->plural($failedRowsCount).' failed to export.';
        }

        return $body;
    }
}
